"use strict";
document.addEventListener('DOMContentLoaded', (event) => {
	/*Welcome page FAQ*/
	var nxtPanelFaq = document.querySelectorAll('.nxt-welcome-faq .nxt-faq-section .faq-title');
	if( nxtPanelFaq ){
		nxtPanelFaq.forEach( function(ele) {
			ele.addEventListener('click', event => {
				event.preventDefault();
				var faqSec = event.currentTarget.nextElementSibling;
				if (!faqSec.classList.contains('active')) {
					event.currentTarget.parentElement.classList.add('faq-active');
					faqSec.classList.add('active');
					faqSec.style.height = 'auto';

					var height = faqSec.clientHeight + 'px';
					faqSec.style.height = '0px';
					setTimeout(function () {
						faqSec.style.height = height;
					}, 0);
				  
				} else {
					faqSec.style.height = '0px';
					faqSec.addEventListener('transitionend', function () {
						faqSec.parentElement.classList.remove('faq-active');
						faqSec.classList.remove('active');
					}, {
						once: true
					});
				}
				
			});
		});
	}
	/*Welcome page FAQ*/
	/*Import Data*/
	var nxtPanelImportBtn = document.querySelector('.nxt-import-data-content .import-step-next');
	if( nxtPanelImportBtn ){
		nxtPanelImportBtn.addEventListener('click', event => {
			event.preventDefault();
			var builderSelect = document.querySelector('.nxt-select-builder input[name="nxt-select-build"]:checked');
			
			if(nxtPanelImportBtn.getAttribute("data-step")=='step-2'){
			
				if( builderSelect && builderSelect.value ){
				
					var buildStep = document.querySelector('.nxt-import-steps'),
						request = new XMLHttpRequest();

					request.open('POST', nexter_admin_config.ajaxurl, true);
					request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;');
					request.onload = function () {
						if (request.status >= 200 && request.status < 400) {
							var response = JSON.parse(request.response);
							if(response.success == true && response.content!=''){
								buildStep.remove();
								nxtPanelImportBtn.setAttribute('data-builder', builderSelect.value);
								var content = document.querySelector('.nxt-import-data-content');
								content.insertAdjacentHTML('afterbegin', response.content);
								if(response.build_status == 'Activated' && response.extension_status == 'Activated'){
									nxtPanelImportBtn.setAttribute('data-step', 'step-3');
								}else{
									nexterInstallBuilder();
								}
							}
						}
					};
					request.send('action=nexter_import_data_step&nexter_nonce=' + nexter_admin_config.ajax_nonce +'&builder=' + builderSelect.value);
				}
				
			}else if(nxtPanelImportBtn.getAttribute("data-step")=='step-3'){
				var buildStep = document.querySelector('.nxt-import-steps'),
					request = new XMLHttpRequest();

				request.open('POST', nexter_admin_config.ajaxurl, true);
				request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;');
				request.onload = function () {
					if (request.status >= 200 && request.status < 400) {
						var response = JSON.parse(request.response);
						if(response.data.success == true && response.data.content!=''){
							buildStep.remove();
							var content = document.querySelector('.nxt-import-data-content');
							content.insertAdjacentHTML('afterbegin', response.data.content);
							nexterImportTemplate();
							if( nxtPanelImportBtn ){
								nxtPanelImportBtn.setAttribute('data-step', 'step-4');
							}
						}else if(response.data.success == false){
							alert('Please Install/Activate Required Plugins');
						}
					}
				};
				request.send('action=nexter_import_data_step_3&nexter_nonce=' + nexter_admin_config.ajax_nonce +'&builder=' + nxtPanelImportBtn.dataset.builder);
			}else if(nxtPanelImportBtn.getAttribute("data-step")=='step-4'){
				var buildStep = document.querySelector('.nxt-import-steps'),
					request = new XMLHttpRequest();

				request.open('POST', nexter_admin_config.ajaxurl, true);
				request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;');
				request.onload = function () {
					if (request.status >= 200 && request.status < 400) {
						var response = JSON.parse(request.response);
						if(response.data.success == true && response.data.content!=''){
							buildStep.remove();
							nxtPanelImportBtn.remove();
							var content = document.querySelector('.nxt-import-data-content');
							content.insertAdjacentHTML('afterbegin', response.data.content);
						}
					}
				};
				request.send('action=nexter_import_data_step_4&nexter_nonce=' + nexter_admin_config.ajax_nonce);
			}
				
		});
	}
	
	var nexterImportTemplate = function(){
		var importTemplate = document.querySelectorAll('.nxt-import-template .nxt-template-import-btn');
		if(importTemplate){
			importTemplate.forEach( function(ele) {
				ele.addEventListener('click', event => {
					event.preventDefault();
					var builder = ele.dataset.builder,
						tag		= ele.dataset.tag,
						template= ele.dataset.template;
					
					if( builder != '' && template != '' ){
						var request = new XMLHttpRequest();

						request.open('POST', nexter_admin_config.ajaxurl, true);
						request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;');
						request.onload = function () {
							if (request.status >= 200 && request.status < 400) {
								var response = JSON.parse(request.response);
								ele.parentElement.classList.remove('import-processing');
								nxtPanelImportBtn.classList.remove('disable-btn');
								if(response.data.success == true && response.data.content!=''){
									ele.innerHTML = response.data.content;
								}else{
									ele.innerHTML = response.data.content;
								}
							}
						};
						ele.parentElement.classList.add('import-processing');
						ele.innerHTML = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="sync-alt" class="fa-spinner" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M457.373 9.387l-50.095 50.102C365.411 27.211 312.953 8 256 8 123.228 8 14.824 112.338 8.31 243.493 7.971 250.311 13.475 256 20.301 256h10.015c6.352 0 11.647-4.949 11.977-11.293C48.159 131.913 141.389 42 256 42c47.554 0 91.487 15.512 127.02 41.75l-53.615 53.622c-20.1 20.1-5.855 54.628 22.627 54.628H480c17.673 0 32-14.327 32-32V32.015c0-28.475-34.564-42.691-54.627-22.628zM480 160H352L480 32v128zm11.699 96h-10.014c-6.353 0-11.647 4.949-11.977 11.293C463.84 380.203 370.504 470 256 470c-47.525 0-91.468-15.509-127.016-41.757l53.612-53.616c20.099-20.1 5.855-54.627-22.627-54.627H32c-17.673 0-32 14.327-32 32v127.978c0 28.614 34.615 42.641 54.627 22.627l50.092-50.096C146.587 484.788 199.046 504 256 504c132.773 0 241.176-104.338 247.69-235.493.339-6.818-5.165-12.507-11.991-12.507zM32 480V352h128L32 480z"></path></svg>';
						nxtPanelImportBtn.classList.add('disable-btn');
						request.send('action=nexter_import_data_template&nexter_nonce=' + nexter_admin_config.ajax_nonce +'&builder=' + builder +'&tag=' + tag +'&template=' + template);
					}
				});
			});
		}
	}
	
	var nexterInstallBuilder = function(){
		/*Install Plugin Builder Event*/
		var nxtPanelInstallBuilderBtn = document.querySelectorAll('.nxt-import-data-content .nxt-install-builder-plugin');
		if(nxtPanelInstallBuilderBtn){
			nxtPanelInstallBuilderBtn.forEach( function(ele) {
				ele.addEventListener('click', event => {
					event.preventDefault();
					var builderSlug = ele.dataset.slug;
					ele.innerHTML = ele.dataset.builderProcess;
					/*Wp Install Plugin Event*/
					wp.updates.installPlugin( {
						slug: builderSlug
					});
				});
			});
			
			/*Wp Install Success trigger Message*/
			jQuery( document ).on('wp-plugin-install-success', ( event, response ) => {
				if(response){
					var builderSlug = (response.slug) ? response.slug : '';
					var installedBuilder = document.querySelector('.nxt-import-data-content .nxt-install-builder-plugin[data-slug=' + builderSlug + ']');
					if(installedBuilder){
						var file = installedBuilder.dataset.file;
						setTimeout( function() {
							var request = new XMLHttpRequest();

							request.open('POST', nexter_admin_config.ajaxurl, true);
							request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;');
							request.onload = function () {
								if (request.status >= 200 && request.status < 400) {
									var response = JSON.parse(request.response);
									if(response.data.success == true && response.data.content!=''){
										installedBuilder.innerHTML = response.data.content;
										if( nxtPanelImportBtn ){
											nxtPanelImportBtn.setAttribute('data-step', 'step-3');
										}
									}else{
										installedBuilder.innerHTML = response.data.content;
									}
								}
							};
							installedBuilder.innerHTML = 'Activating..';
							request.send('action=nexter_import_activate_builder&nexter_nonce=' + nexter_admin_config.ajax_nonce +'&file=' + file);
						}, 1200);
					}
				}
			});
			
			/*Wp Install Error trigger Message*/
			jQuery( document ).on('wp-plugin-install-error', ( event, response ) => {
				var installedBuilder = document.querySelector('.nxt-import-data-content .nxt-install-builder-plugin');
				if(installedBuilder){
					installedBuilder.innerHTML = wp.updates.l10n.installFailedShort;
				}
			});
		}
		
		/*Activate Plugin Builder Event*/
		var nxtActiveBuilderBtn = document.querySelectorAll('.nxt-import-data-content .nxt-active-builder-plugin');
		if( nxtActiveBuilderBtn ){
			nxtActiveBuilderBtn.forEach( function(ele) {
				ele.addEventListener('click', event => {
					event.preventDefault();
					
					var builder = ele.dataset.builder,
						processText = ele.dataset.builderProcess,
						file = ele.dataset.file;
						
					if(builder!='' && ele.innerHTML != "Activated"){
						var request = new XMLHttpRequest();

						request.open('POST', nexter_admin_config.ajaxurl, true);
						request.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded;');
						request.onload = function () {
							if (request.status >= 200 && request.status < 400) {
								var response = JSON.parse(request.response);
								if(response.data.success == true && response.data.content!=''){
									ele.innerHTML = response.data.content;
									if( nxtPanelImportBtn ){
										nxtPanelImportBtn.setAttribute('data-step', 'step-3');
									}
								}else{
									ele.innerHTML = response.data.content;
								}
							}
						};
						
						ele.innerHTML = processText;
						request.send('action=nexter_import_activate_builder&nexter_nonce=' + nexter_admin_config.ajax_nonce +'&builder=' + builder+'&file=' + file);
					}
					
				});
			});
		}
	}
	/*Import Data*/
});