<?php 
/**
 * Nexter Settings Panel
 *
 * @package	Nexter
 * @since	1.0.0
 */
if (!defined('ABSPATH')) {
    exit;
}
/**
 * White Label Content
 */
function nexter_white_label_content(){
	echo '<div class="nxt-pro-note-title"><p style="margin-bottom:50px;">'.esc_html__('White Label our plugin and setup client\'s branding all around. You can update name, description, Icon and even hide the menu from dashboard. Get our pro version to have access of this feature.','nexter').'</p></div>
		<div style="text-align:center;">
			<img style="width:55%;" src="'.esc_url(NXT_THEME_URI .'assets/images/white-lable.png').'" alt="'.esc_attr__('White Label','nexter').'" class="panel-plus-white-lable" />
		</div>';
}
add_action('nexter_white_label_notice', 'nexter_white_label_content' );

/**
 * Activate Content
 */
function nexter_activate_content(){
	echo '<div class="nxt-pro-note-title"><p style="margin-bottom:40px;">'.esc_html__('Upgrade to Pro version to get lots more Features and Lot more.','nexter').'</p></div>
		<div style="text-align:center;">
			<img style="width:55%;" src="'.esc_url(NXT_THEME_URI .'assets/images/activate.png').'" alt="'.esc_attr__('Activate','nexter').'" class="panel-plus-activate" />
		</div>
		<div class="nxt-pro-note-link"><a href="'.esc_url('https://nexterwp.com/free-vs-pro-compare/').'" target="_blank">'.esc_html__('Compare Free vs Pro','nexter').'</a></div>';
}
add_action('nexter_activate_notice', 'nexter_activate_content' );

/**
 * Performance Notice Content
 */
function nexter_site_performance_notice_content(){
	echo '<div class="nxt-pro-note-title"><p style="margin-bottom:40px;">'.esc_html__('Install & Activate "Nexter Extension" plugin to use available options.','nexter').'</p></div>
		<div class="nxt-pro-note-link">'.nexter_ext_plugin_load_notice().'</div>';
}
add_action('nexter_site_performance_notice', 'nexter_site_performance_notice_content' );

/**
 * Security Notice Content
 */
function nexter_site_security_notice_content(){
	echo '<div class="nxt-pro-note-title"><p style="margin-bottom:40px;">'.esc_html__('Install & Activate "Nexter Extension" plugin to use available options.','nexter').'</p></div>
		<div class="nxt-pro-note-link">'.nexter_ext_plugin_load_notice().'</div>';
}
add_action('nexter_site_security_notice', 'nexter_site_security_notice_content' );



/**
 * Nexter Extensions load Notice
 */
function nexter_ext_plugin_load_notice() {
	$plugin = 'nexter-extension/nexter-extension.php';
	$output = '';
	$installed_plugins = get_plugins();
	if ( isset( $installed_plugins[ $plugin ] ) ) {
		if ( ! current_user_can( 'activate_plugins' ) ) { return; }
		$activation_url = wp_nonce_url( 'plugins.php?action=activate&amp;plugin=' . $plugin . '&amp;plugin_status=all&amp;paged=1&amp;s', 'activate-plugin_' . $plugin );
		$output .= sprintf( '<a href="%s">%s</a>', $activation_url, esc_html__( 'Activate Nexter Extensions', 'nexter' ) );
	} else {
		if ( ! current_user_can( 'install_plugins' ) ) { return; }
		$install_url = wp_nonce_url( self_admin_url( 'update.php?action=install-plugin&plugin=nexter-extension' ), 'install-plugin_nexter-extension' );
		$output .= sprintf( '<a href="%s">%s</a>', $install_url, esc_html__( 'Install Nexter Extension', 'nexter' ) );
	}
	return wp_kses_post($output);
}

/**
 * Extra Options Import Export Customizer
 * @since 1.0.11
 */
function nexter_extra_options_content(){
	
	if(defined('NXT_PRO_EXT')){
		$options = get_option( 'nexter_white_label' );
		$theme_name = (!empty($options['brand_name'])) ? $options['brand_name'] : esc_html__('Nexter', 'nexter');
	}else{
		$theme_name = esc_html__('Nexter Settings', 'nexter');
	}
	?>
	<div class="nxt-customizer-import-export">
		<div class="nxt-sec-title nxt-ie-heading-title"><?php echo esc_html__( 'Import & Export of Theme Customizer Settings', 'nexter' ); ?></div>
		<div class="nxt-customizer-export-wrap">
			<h3 class="nxt-cust-ie-title"><span><svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="file-download" class="svg-inline--fa fa-file-download" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512" width="25"><path fill="currentColor" d="M369.9 97.98L286.02 14.1c-9-9-21.2-14.1-33.89-14.1H47.99C21.5.1 0 21.6 0 48.09v415.92C0 490.5 21.5 512 47.99 512h288.02c26.49 0 47.99-21.5 47.99-47.99V131.97c0-12.69-5.1-24.99-14.1-33.99zM256.03 32.59c2.8.7 5.3 2.1 7.4 4.2l83.88 83.88c2.1 2.1 3.5 4.6 4.2 7.4h-95.48V32.59zm95.98 431.42c0 8.8-7.2 16-16 16H47.99c-8.8 0-16-7.2-16-16V48.09c0-8.8 7.2-16.09 16-16.09h176.04v104.07c0 13.3 10.7 23.93 24 23.93h103.98v304.01zM208 216c0-4.42-3.58-8-8-8h-16c-4.42 0-8 3.58-8 8v88.02h-52.66c-11 0-20.59 6.41-25 16.72-4.5 10.52-2.38 22.62 5.44 30.81l68.12 71.78c5.34 5.59 12.47 8.69 20.09 8.69s14.75-3.09 20.09-8.7l68.12-71.75c7.81-8.2 9.94-20.31 5.44-30.83-4.41-10.31-14-16.72-25-16.72H208V216zm42.84 120.02l-58.84 62-58.84-62h117.68z"></path></svg></span><?php echo esc_html__( 'Export Settings', 'nexter' ); ?></h3>
			<p><?php echo esc_html__( 'Export all your theme customizer settings using below button.', 'nexter' ); ?></p>
			<form method="post">
				<input type="hidden" name="nxt_customizer_export_action" value="nxt_export_cust" />
				<p style="margin-bottom:0">
					<?php wp_nonce_field( 'nexter_export_cust_nonce', 'nexter_export_cust_nonce' ); ?>
					<?php submit_button( __( 'Export Settings', 'nexter' ), 'nxt-cust-ie-btn', 'submit', false, array( 'id' => '' ) ); ?>
				</p>
			</form>
		</div>
		<div class="nxt-customizer-import-wrap">
			<h3 class="nxt-cust-ie-title"><span><svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="file-upload" class="svg-inline--fa fa-file-upload fa-w-12" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 384 512" width="25"><path fill="currentColor" d="M369.9 97.98L286.02 14.1c-9-9-21.2-14.1-33.89-14.1H47.99C21.5.1 0 21.6 0 48.09v415.92C0 490.5 21.5 512 47.99 512h288.02c26.49 0 47.99-21.5 47.99-47.99V131.97c0-12.69-5.1-24.99-14.1-33.99zM256.03 32.59c2.8.7 5.3 2.1 7.4 4.2l83.88 83.88c2.1 2.1 3.5 4.6 4.2 7.4h-95.48V32.59zm95.98 431.42c0 8.8-7.2 16-16 16H47.99c-8.8 0-16-7.2-16-16V48.09c0-8.8 7.2-16.09 16-16.09h176.04v104.07c0 13.3 10.7 23.93 24 23.93h103.98v304.01zm-180.1-247.32l-68.12 71.75c-7.81 8.2-9.94 20.31-5.44 30.83 4.41 10.31 14 16.72 25 16.72H176V424c0 4.42 3.58 8 8 8h16c4.42 0 8-3.58 8-8v-88.02h52.66c11 0 20.59-6.41 25-16.72 4.5-10.52 2.38-22.62-5.44-30.81l-68.12-71.78c-10.69-11.19-29.51-11.2-40.19.02zm-38.75 87.29l58.84-62 58.84 62H133.16z"></path></svg></span><?php echo esc_html__( 'Import Settings', 'nexter' ); ?></h3>
			<p><?php echo esc_html__( 'Import file to get all your customizer settings.', 'nexter' ); ?></p>
			<form method="post" enctype="multipart/form-data">
				<p><input type="file" name="nxt_import_file"/></p>
				<p style="margin-bottom:0">
					<input type="hidden" name="nxt_customizer_import_action" value="nxt_import_cust" />
					<?php wp_nonce_field( 'nexter_import_cust_nonce', 'nexter_import_cust_nonce' ); ?>
					<?php submit_button( __( 'Import', 'nexter' ), 'nxt-cust-ie-btn', 'submit', false, array( 'id' => '' ) ); ?>
				</p>
			</form>
			<?php 
				$imported = ( isset($_GET['status_customizer']) && !empty($_GET['status_customizer']) ) ? sanitize_text_field($_GET['status_customizer']) : '';
				if(!empty($imported) && $imported=='success'){
					echo '<div class="nxt-import-success-msg">'.esc_html__( 'Success! All Settings are Imported. Check that in Theme Customer.', 'nexter' ).'</div>';
				}
			?>
		</div>
	</div>
	<?php
}
add_action('nexter_extra_options_render', 'nexter_extra_options_content' );
	
/**
 * Import Data Content
 */
function nexter_import_data_content(){
	echo '<div class="nxt-import-data-content">
			<div class="nxt-import-steps import-step-1 active" data-step="step-1">
				<div class="nxt-import-heading">'.esc_html__('Which page builder are you using?','nexter').'</div>
				<div class="nxt-select-builder">
					<input type="radio" name="nxt-select-build" id="builder-gutenberg" value="gutenberg" />
					<label class="nxt-builder-select" for="builder-gutenberg">
						<span><img src="'.esc_url(NXT_THEME_URI .'assets/images/gutenberg.png').'" alt="'.esc_attr__('Gutenberg','nexter').'" /></span>
						<span>'.esc_html__('Gutenberg','nexter').'</span>
					</label>
					<input type="radio" name="nxt-select-build" id="builder-elementor" value="elementor" />
					<label class="nxt-builder-select" for="builder-elementor">
						<span><img src="'.esc_url(NXT_THEME_URI .'assets/images/elementor.png').'" alt="'.esc_attr__('Elementor','nexter').'" /></span>
						<span>'.esc_html__('Elementor','nexter').'</span>
					</label>
					<input type="radio" name="nxt-select-build" id="builder-beaver" value="beaver" />
					<label class="nxt-builder-select" for="builder-beaver">
						<span><img src="'.esc_url(NXT_THEME_URI .'assets/images/beaver.png').'" alt="'.esc_attr__('Beaver','nexter').'" /></span>
						<span>'.esc_html__('Beaver','nexter').'</span>
					</label>
				</div>
			</div>
			<div class="nxt-import-step-btn"><a href="#" class="import-step-next" data-step="step-2">'.esc_html__('Next','nexter').'</a></div>
		</div>';
}
add_action('nexter_import_data_render', 'nexter_import_data_content' );

class Nexter_Settings_Panel {
	
	/**
     * Option key, and option page slug
     */
    private $key = 'nexter_settings_opts';
	
	/**
     * Array of meta boxes/fields
     * @var array
     */
    protected $option_metabox = array();
    
	/**
     * Setting Name/Title
     * @var string
     */
    protected $setting_name = '';
	
	/**
     * Constructor
     * @since 1.0.0
     */
    public function __construct() {
		
		if(defined('NXT_PRO_EXT')){
			$options = get_option( 'nexter_white_label' );
			$this->setting_name = (!empty($options['brand_name'])) ? $options['brand_name'].esc_html__(' Settings', 'nexter') : esc_html__('Nexter Settings', 'nexter');
		}else{
			$this->setting_name = esc_html__('Nexter Settings', 'nexter');
		}
		
        $this->fields = array();
    }
	
	/**
     * Initiate hooks
	 * @since 1.0.11
     */
	public function hooks() {
        add_action('admin_init', array( $this,'init' ) );
        add_action('admin_menu', array( $this, 'nxt_add_menu_page' ));
		
		add_action( 'wp_ajax_nexter_import_data_step', [ $this, 'nexter_import_data_step_2' ] );
		add_action( 'wp_ajax_nexter_import_data_step_3', [ $this, 'nexter_import_data_step_3'] );
		add_action( 'wp_ajax_nexter_import_activate_builder', [ $this, 'nexter_import_activate_builder_ajax'] );
		
		add_action( 'admin_init', [ $this, 'nxt_customizer_export_data' ] );
		add_action( 'admin_init', [ $this, 'nxt_customizer_import_data' ] );
    }
	
	public function nexter_import_activate_builder_ajax(){
		check_ajax_referer( 'nexter_admin_nonce', 'nexter_nonce' );
		
		if ( ! current_user_can( 'install_plugins' ) || ! isset( $_POST['file'] ) || ! sanitize_text_field( wp_unslash( $_POST['file'] ) ) ) {
			wp_send_json_error(
				array(
					'success' => false,
					'content' => __( 'No plugin..', 'nexter' ),
				)
			);
		}

		$file = ( isset( $_POST['file'] ) ) ? sanitize_text_field( wp_unslash( $_POST['file'] ) ) : '';

		$activate = activate_plugin( $file, '', false, true );

		if ( is_wp_error( $activate ) ) {
			wp_send_json_error(
				array(
					'success'	=> false,
					'content'	=> $activate->get_error_message(),
				)
			);
		}

		wp_send_json_success(
			array(
				'success'	=> true,
				'content'	=> __( 'Activated', 'nexter' ),
			)
		);

	}
	
	public function nexter_import_data_step_2(){
		check_ajax_referer( 'nexter_admin_nonce', 'nexter_nonce' );
		
		if(current_user_can( 'install_plugins' ) && isset($_POST['builder']) && !empty($_POST['builder'])){
			$build_thumb = $build_name = $build_button = '';
			$plugin_slug = $plugin_file = '';
			$plugin_process = $plugin_status = '';
			$installed_plugins = get_plugins();
			
			if($_POST['builder'] == 'elementor'){
				$build_thumb = 'tpae';
				$build_name = 'Elementor';
				$plugin_file = 'the-plus-addons-for-elementor-page-builder/theplus_elementor_addon.php';
				$plugin_slug = 'the-plus-addons-for-elementor-page-builder';
				if(!defined("L_THEPLUS_VERSION")){
					if ( isset( $installed_plugins[ $plugin_file ] ) ) {
						$build_button = 'Active Plugin';
						$plugin_process = 'Activating..';
						$plugin_status = 'nxt-active-builder-plugin';
					}else{
						$build_button = 'Install Plugin';
						$plugin_process = 'Installing..';
						$plugin_status = 'nxt-install-builder-plugin';
					}
				}else if(defined("L_THEPLUS_VERSION")){
					$build_button = 'Activated';
					$plugin_process = 'Activated';
					$plugin_status = 'nxt-activated-builder-plugin';
				}
			}else if($_POST['builder'] == 'gutenberg'){
				$build_thumb = 'tpag';
				$build_name = 'Gutenberg';
				$plugin_file = 'the-plus-addons-for-block-editor/the-plus-addons-for-block-editor.php';
				$plugin_slug = 'the-plus-addons-for-block-editor';
				if(!defined("TPGB_VERSION")){
					if ( isset( $installed_plugins[ $plugin_file ] ) ) {
						$build_button = 'Active Plugin';
						$plugin_process = 'Activating..';
						$plugin_status = 'nxt-active-builder-plugin';
					}else{
						$build_button = 'Install Plugin';
						$plugin_process = 'Installing..';
						$plugin_status = 'nxt-install-builder-plugin';
					}
				}else if(defined("TPGB_VERSION")){
					$build_button = 'Activated';
					$plugin_process = 'Activated';
					$plugin_status = 'nxt-activated-builder-plugin';
				}
			}
			
			$nxt_ext_file = 'nexter-extension/nexter-extension.php';
			$nxt_build_button = $nxt_plugin_process = $nxt_plugin_status = '';
			if(!defined("NEXTER_EXT_VER")){
				if ( isset( $installed_plugins[ $nxt_ext_file ] ) ) {
					$nxt_build_button = 'Active Plugin';
					$nxt_plugin_process = 'Activating..';
					$nxt_plugin_status = 'nxt-active-builder-plugin';
				}else{
					$nxt_build_button = 'Install Plugin';
					$nxt_plugin_process = 'Installing..';
					$nxt_plugin_status = 'nxt-install-builder-plugin';
				}
			}else if(defined("NEXTER_EXT_VER")){
				$nxt_build_button = 'Activated';
				$nxt_plugin_process = 'Activated';
				$nxt_plugin_status = 'nxt-activated-builder-plugin';
			}
			
			$output = '<div class="nxt-import-steps import-step-2 active" data-step="step-2">
				<div class="nxt-import-heading">'.esc_html__('Install & Activate Required Plugins.','nexter').'</div>
				<div class="nxt-panel-row">
					<div class="nxt-panel-col nxt-panel-col-50">
						<div class="nxt-builder-install-activate">
							<div class="builder-thumb" style="background-image:url('.esc_url(NXT_THEME_URI .'assets/images/'.$build_thumb.'.png').')"></div>
							<div class="builder-name">'.esc_html__('The Plus Addons For ','nexter').esc_html($build_name).'<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="info-circle" class="svg-inline--fa fa-info-circle fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M256 40c118.621 0 216 96.075 216 216 0 119.291-96.61 216-216 216-119.244 0-216-96.562-216-216 0-119.203 96.602-216 216-216m0-32C119.043 8 8 119.083 8 256c0 136.997 111.043 248 248 248s248-111.003 248-248C504 119.083 392.957 8 256 8zm-36 344h12V232h-12c-6.627 0-12-5.373-12-12v-8c0-6.627 5.373-12 12-12h48c6.627 0 12 5.373 12 12v140h12c6.627 0 12 5.373 12 12v8c0 6.627-5.373 12-12 12h-72c-6.627 0-12-5.373-12-12v-8c0-6.627 5.373-12 12-12zm36-240c-17.673 0-32 14.327-32 32s14.327 32 32 32 32-14.327 32-32-14.327-32-32-32z"></path></svg></div>
						</div>
						<a href="#" class="builder-install-activate-plugin '.esc_attr($plugin_status).'" data-builder="'.esc_attr($_POST['builder']).'" data-builder-process="'.esc_attr($plugin_process).'" data-slug="'.esc_attr($plugin_slug).'" data-file="'.$plugin_file.'">'.esc_html($build_button).'</a>
					</div>
					<div class="nxt-panel-col nxt-panel-col-50">
						<div class="nxt-builder-install-activate nxt-ext-plugin">
							<div class="builder-thumb" style="background-image:url('.esc_url(NXT_THEME_URI .'assets/images/nexter-ext.png').')"></div>
							<div class="builder-name">'.esc_html__('Nexter Extension','nexter').'<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="info-circle" class="svg-inline--fa fa-info-circle fa-w-16" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M256 40c118.621 0 216 96.075 216 216 0 119.291-96.61 216-216 216-119.244 0-216-96.562-216-216 0-119.203 96.602-216 216-216m0-32C119.043 8 8 119.083 8 256c0 136.997 111.043 248 248 248s248-111.003 248-248C504 119.083 392.957 8 256 8zm-36 344h12V232h-12c-6.627 0-12-5.373-12-12v-8c0-6.627 5.373-12 12-12h48c6.627 0 12 5.373 12 12v140h12c6.627 0 12 5.373 12 12v8c0 6.627-5.373 12-12 12h-72c-6.627 0-12-5.373-12-12v-8c0-6.627 5.373-12 12-12zm36-240c-17.673 0-32 14.327-32 32s14.327 32 32 32 32-14.327 32-32-14.327-32-32-32z"></path></svg></div>
						</div>
						<a href="#" class="builder-install-activate-plugin '.esc_attr($nxt_plugin_status).'" data-builder="nexter-extension" data-builder-process="'.esc_attr($nxt_plugin_process).'" data-slug="nexter-extension" data-file="'.$nxt_ext_file.'">'.esc_html($nxt_build_button).'</a>
					</div>
				</div>
			</div>';
			
			echo wp_json_encode( [ 'success'=> true, 'content'=> $output, 'build_status' => $build_button, 'extension_status' => $nxt_build_button] );
			exit;
		}else{
			echo wp_json_encode( [ 'success'=> false, 'content'=> '', 'build_status' => $build_button, 'extension_status' => $nxt_build_button ] );
			exit;
		}
	}
	
	public function nexter_import_data_step_3(){
		check_ajax_referer( 'nexter_admin_nonce', 'nexter_nonce' );
		
		$builder = ( isset( $_POST['builder'] ) ) ? sanitize_text_field( wp_unslash( $_POST['builder'] ) ) : '';
		
		$success = true;
		$builder_template = [];
		if(!empty($builder) && $builder=='gutenberg'){
			if(!defined("TPGB_VERSION")){
				$success = false;
			}else{
				$builder_template['template-1'] = [ 
					'thumb' => 'gutenberg-temp-1.png',
					'title' => esc_html__('Builder Template','nexter'),
					'desc' => esc_html__('Header, Footer, Single Posts Template, Archive Template...','nexter'),
					'tag' => 'Free',
				];
				$builder_template['posts'] = [ 
					'thumb' => 'gutenberg-temp-1.png',
					'title' => esc_html__('Basic Posts','nexter'),
					'desc' => esc_html__('Normal basic posts demo','nexter'),
					'tag' => 'Free',
				];
				
				$option_page = 'tpgb_normal_blocks_opts';
				$sub_option = 'enable_normal_blocks';
				$merge_opt = [ 'tp-row','tp-post-title', 'tp-post-author', 'tp-post-comment', 'tp-post-content', 'tp-post-image', 'tp-post-listing', 'tp-post-meta', 'tp-site-logo' ];
				if ( FALSE === get_option($option_page) ){
					$default_value = [ $sub_option => $merge_opt ];
					add_option($option_page,$default_value);
				}else{
					$get_option = get_option($option_page);
					if( !empty( $get_option ) && isset( $get_option[ $sub_option ] ) ){
						$get_sub_opt = $get_option[ $sub_option ];
						
						if( is_array( $get_sub_opt ) && !empty( $get_sub_opt ) ){
							$new_val = array_merge($get_sub_opt,$merge_opt);
							$update_value = array( $sub_option => $new_val);
						}else if(empty( $get_sub_opt ) ){
							$update_value = array( $sub_option => $merge_opt );
						}else{
							$update_value = array( $sub_option => $get_sub_opt);
						}
						update_option( $option_page, $update_value );
					}
				}
				
			}
		}else if(!empty($builder) && $builder=='elementor'){
			if(!defined("L_THEPLUS_VERSION")){
				$success = false;
			}else{
				$builder_template['template-1'] = [ 
					'thumb' => 'gutenberg-temp-1.png',
					'title' => esc_html__('Build Template','nexter'),
					'desc' => esc_html__('Header, Footer, Single Posts Template, Archive Template...','nexter'),
					'tag' => 'Free',
				];
				$builder_template['posts'] = [ 
					'thumb' => 'gutenberg-temp-1.png',
					'title' => esc_html__('Basic Posts','nexter'),
					'desc' => esc_html__('Normal basic posts demo','nexter'),
					'tag' => 'Free',
				];
				
				$option_page = 'theplus_options';
				$sub_option1 = 'check_elements';
				$sub_option2 = 'extras_elements';
				$merge_opt = [ 'tp_blog_listout', 'tp_navigation_menu_lite', 'tp_post_search', 'tp_post_title', 'tp_post_content', 'tp_post_featured_image', 'tp_post_meta', 'tp_post_author', 'tp_post_comment' ];
				if ( FALSE === get_option($option_page) ){
					$default_value = [ $sub_option1 => $merge_opt, $sub_option2 => '' ];
					add_option($option_page,$default_value);
				}else{
					$get_option = get_option($option_page);
					if( !empty( $get_option ) ){
					
						$old_sub_opt1 = $get_option[ $sub_option1 ];
						$old_sub_opt2 = $get_option[ $sub_option2 ];
						$update_value = [];
						if( is_array( $old_sub_opt1 ) && !empty( $old_sub_opt1 ) ){
							$new_val = array_merge($old_sub_opt1,$merge_opt);
							$update_value[ $sub_option1 ] = $new_val;
						}else if(empty( $old_sub_opt1 ) ){
							$update_value[ $sub_option1 ] = $merge_opt;
						}else{
							$update_value[ $sub_option1 ] = $old_sub_opt1;
						}
						$update_value[ $sub_option2 ] = $old_sub_opt2;
						update_option( $option_page, $update_value );
					}
				}
			}
		}
		
		if(!defined("NEXTER_EXT_VER")){
			$success = false;
		}
		
		$output = '<div class="nxt-import-steps import-step-3 active" data-step="step-3">
					<div class="nxt-import-heading">'.esc_html__('Import Demo Data','nexter').'</div>
					<div class="nxt-panel-row nxt-import-demo-data">';
						if(!empty($builder_template)){
							foreach($builder_template as $key => $value){
								$output .= '<div class="nxt-panel-col">';
									$output .= '<div class="nxt-import-template">';
										if(!empty($value['tag'])){
											$output .= '<div class="template-tag" data-tag="'.esc_attr($value['tag']).'">'.esc_html($value['tag']).'</div>';
										}
										if(!empty($value['thumb'])){
											$output .= '<img src="'.esc_url(NXT_THEME_URI .'assets/images/'.$value['thumb']).'" class="template-thumb" />';
										}
										if(!empty($value['title'])){
											$output .= '<div class="template-name">'.esc_html($value['title']).'</div>';
										}
										if(!empty($value['desc'])){
											$output .= '<div class="template-desc">'.esc_html($value['desc']).'</div>';
										}
										if( !empty($key) ){
											$output .= '<a href="#" class="nxt-template-import-btn" data-builder="'.esc_attr($builder).'" data-tag="'.esc_attr($value['tag']).'" data-template="'.esc_attr($key).'">'.esc_html__('Import','nexter').'</a>';
										}
									$output .= '</div>';
								$output .= '</div>';
							}
						}
		$output .= '</div>
				</div>';
				
		if( $success ){
			wp_send_json_success( [ 'success' => true, 'content' => $output ] );
		}else{
			wp_send_json_error( [ 'success'	=> false, 'content'	=> '' ] );
		}
	}
	
	/**
     * Register nexter setting to WP
     */
    public function init() {
        $option_tabs = self::option_fields();
		
        foreach ($option_tabs as $index => $option_tab) {
            register_setting($option_tab['id'], $option_tab['id']);
        }
    }
	
	/**
     * Add menu options page
     */
    public function nxt_add_menu_page() {
		$option_tabs = self::option_fields();
		global $_registered_pages, $submenu;
		
		unset($submenu['themes.php'][20]);
		unset($submenu['themes.php'][15]);
		
		foreach ($option_tabs as $index => $option_tab) {
			if($index == 0){
				add_theme_page($this->setting_name, $this->setting_name, 'manage_options', $option_tab['id'], array(
					$this,
					'admin_page_display'
				));
			}else{
				if(isset($option_tabs) && $option_tab['id'] != "nexter_white_label" && $option_tab['id'] != "nexter_activate"){
					$function_name = array( $this,'admin_page_display');
					$hookname = get_plugin_page_hookname( $option_tab['id'], $option_tabs[0]['id'] );
					if ( ! empty( $function_name ) && ! empty( $hookname ) ) {
						add_action( $hookname, $function_name );
					}
					$_registered_pages[ $hookname ] = true;	// phpcs:ignore WordPress.WP.GlobalVariablesOverride.Prohibited
				}else{
					$label_options=get_option( 'nexter_white_label' );	
					if( ((empty($label_options['nxt_hidden_label']) || $label_options['nxt_hidden_label']!='on') && ($option_tab['id'] == "nexter_white_label" || $option_tab['id'] == "nexter_activate")) || !defined('NXT_PRO_EXT_VER')){
						$function_name = array( $this,'admin_page_display');
						$hookname = get_plugin_page_hookname( $option_tab['id'], $option_tabs[0]['id'] );
						if ( ! empty( $function_name ) && ! empty( $hookname ) ) {
							add_action( $hookname, $function_name );
						}
						$_registered_pages[ $hookname ] = true;	// phpcs:ignore WordPress.WP.GlobalVariablesOverride.Prohibited
					}
				}
			}
		}
    }
	
	/**
     * Theplus Gutenberg Display Page
     * @since  1.0.0
     */
    public function admin_page_display() {
		$option_tabs = self::option_fields();
		$tab_forms   = array();
		
		$output ='';
		
		$output .='<div class="'.esc_attr($this->key).'">';
			
			$output .='<div id="nxt-setting-header-wrapper">';
				$output .='<div class="nxt-head-inner">';
				
					$options = get_option( 'nexter_white_label' );
					if(defined('NXT_PRO_EXT') && (!empty($options['theme_logo']))){
						$output .='<img src="'.esc_url($options['theme_logo']).'" style="max-width:150px;"/>';
					}else{
						$output .='<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" width="200" viewBox="0 0 865.58 276.42"><defs><clipPath transform="translate(-561.27 -385.08)"><rect width="1920" height="1080" style="fill:none"/></clipPath></defs><title>Nexter</title><polygon points="195.86 96.47 151.62 0.76 121.98 0.76 121.98 272.27 151.62 272.27 151.62 49.42 195.8 145.11 195.86 272.27 225.5 272.27 225.5 0.76 195.86 0.76 195.86 96.47" style="fill:#fff"/><g style="clip-path:url(#3002fa26-8adc-47a4-847a-87495272d705)"><path d="M1011.75,550.7c0,1.93-1.16,3.43-3.47,4.52l-18.76,7.26-18.78-7.15c-2.32-1.06-3.47-2.59-3.47-4.53V385.19l-29.61-.11V551.24q0,13.95,16.91,22.1l5.31,2.53-5.31,2.54q-16.91,8.15-16.91,22.06v56.11h29.69V601.21c0-2,1.16-3.63,3.47-4.72l18.7-7.23,18.68,7.23c2.31,1.09,3.47,2.68,3.47,4.72v55.37h29.75V600.47q0-13.9-16.92-22.06l-5.31-2.54,5.31-2.53q16.9-8.15,16.92-22.1V385.08h-29.67Z" transform="translate(-561.27 -385.08)" style="fill:#fff"/><polygon points="512.73 23.95 548.43 23.92 548.43 272.27 577.99 272.27 578.09 23.92 613.74 23.92 613.74 0.76 512.76 0.76 512.73 23.95" style="fill:#fff"/><path d="M1408,604.24q18.81-6.35,18.79-23.35V411.18c0-7-3.23-13-9.62-18s-11.15-7.53-19.94-7.53h-71.34V657.18h29.64v0h0V615.84h30.21c.25,0,.46.09.69.12a14.56,14.56,0,0,1,3.81.93c.4.14.76.3,1.13.47l.3.14a9.54,9.54,0,0,1,4.58,4.32l.12.22a9.17,9.17,0,0,1,.46,1.21,8.64,8.64,0,0,1,.24.83,13.57,13.57,0,0,1,.35,3l-.14,30.11h0v0h29.67v-29.4c0-11.35-6.36-19.21-18.9-23.54m-10.77-21.36a8.52,8.52,0,0,1-3.72,6.87,14.13,14.13,0,0,1-9,2.9h-29V409h34.82a7.83,7.83,0,0,1,4.85,1.55,4.61,4.61,0,0,1,2.09,3.87Z" transform="translate(-561.27 -385.08)" style="fill:#fff"/><polygon points="258.11 272.24 343.8 272.24 343.8 249.03 287.83 249.03 287.83 202.52 327.5 202.52 327.5 179.34 287.83 179.34 287.83 23.92 343.8 23.92 343.8 0.74 258.11 0.74 258.11 272.24" style="fill:#fff"/><polygon points="646.32 23.95 702.32 23.98 702.32 84.61 662.66 84.61 662.66 107.82 702.29 107.82 702.29 249.08 646.32 249.08 646.32 272.27 732.04 272.27 732.04 0.76 646.32 0.76 646.32 23.95" style="fill:#fff"/><path d="M605.76,630.6l-.14,30.9H561.27V618.58h32.08c.28,0,.49.1.73.13a15.32,15.32,0,0,1,4,1c.41.14.83.32,1.22.49.1.07.21.11.31.18a10,10,0,0,1,4.85,4.6c.07.11.1.18.14.24a8.36,8.36,0,0,1,.49,1.29,5.33,5.33,0,0,1,.24.91,13.24,13.24,0,0,1,.38,3.17" transform="translate(-561.27 -385.08)" style="fill:#fff"/><path d="M605.62,402.47v180.7c0,2.82-1.29,5.26-3.94,7.36a14.86,14.86,0,0,1-9.59,3.1H561.27v-197h37a8.31,8.31,0,0,1,5.16,1.67,5,5,0,0,1,2.19,4.15" transform="translate(-561.27 -385.08)" style="fill:#fff"/></g></svg>';
					}
					$output .='<div class="nxt-panel-head-inner">';
						$output .='<h2 class="nxt-head-setting-panel">'.esc_html__('Setting Panel','nexter').'</h2>';
						$output .='<div class="nxt-current-version"> '.esc_html__('Version','nexter').' '.NXT_VERSION.'</div>';
					$output .='</div>';
				$output .='</div>';
				
				$output .='<div class="nxt-nav-tab-wrapper">';
					$output .='<div class="nav-tab-wrapper">';
						ob_start();
						foreach ($option_tabs as $option_tab):
							$tab_slug  = $option_tab['id'];
							$nav_class = 'nav-tab';
							if (isset($_GET['page']) && $tab_slug == $_GET['page']) {
								$nav_class .= ' nav-tab-active'; //add active class to current tab
								$tab_forms[] = $option_tab; //add current tab to forms to be rendered
							}
							$navicon = $nav_url ='';
							
							if($tab_slug == "nexter_settings_welcome" || $tab_slug == "nexter_import_data"){
								wp_enqueue_script( 'nexter-panel-setting' );
							}
							if($tab_slug == "nexter_settings_welcome"){
								$nav_url = menu_page_url($tab_slug, false);
								$navicon = '<svg class="tab-nav-icon" version="1.1" xmlns="http://www.w3.org/2000/svg" width="120" height="120" viewBox="0 0 120 120" preserveAspectRatio="none">
											<path d="M109.148 120h-36c-1.104 0-2-0.9-2-2v-34h-20v34c0 1.1-0.896 2-2 2h-36c-1.104 0-2-0.9-2-2v-62h-8.648c-0.832 0-1.576-0.512-1.868-1.288-0.296-0.776-0.080-1.652 0.54-2.204l57.324-51c0.736-0.656 1.836-0.676 2.596-0.056l14.060 11.54v-10.992c0-1.104 0.896-2 2-2h20c1.1 0 2 0.896 2 2v31.648l19.74 18.908c0.588 0.568 0.776 1.432 0.472 2.192-0.308 0.756-1.044 1.252-1.86 1.252h-6.356v62c0 1.1-0.896 2-2 2zM75.148 116h32v-62c0-1.104 0.896-2 2-2h3.376l-16.756-16.056c-0.396-0.376-0.612-0.9-0.612-1.444v-30.5h-16v13.22c0 0.772-0.44 1.48-1.144 1.808-0.7 0.328-1.528 0.232-2.124-0.26l-16-13.136-52.124 46.368h5.396c1.104 0 2 0.896 2 2v62h32v-34c0-1.1 0.896-2 2-2h24c1.104 0 2 0.9 2 2v34h-0.012z"></path>
										</svg>';
							}
							if($tab_slug == "nexter_activate"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg class="tab-nav-icon" xmlns="http://www.w3.org/2000/svg" width="15.204" height="28.507" viewBox="0 0 15.204 28.507"><g transform="translate(22.204) rotate(90)"><path d="M10.967,22.2H2.553A2.969,2.969,0,0,1,0,19.521V8.732C0,7.663.979,7,2.553,7h8.413C12.43,7,13.3,7.648,13.3,8.732v3.019H28.032a.476.476,0,0,1,.475.475v4.751a.477.477,0,0,1-.475.475H13.3V19.52A2.749,2.749,0,0,1,10.967,22.2ZM2.553,7.95c-.164,0-1.6.022-1.6.782V19.521a2.061,2.061,0,0,0,1.6,1.732h8.413c.67,0,1.386-1.016,1.386-1.731V16.977a.476.476,0,0,1,.475-.475H27.557V12.7H12.828a.475.475,0,0,1-.475-.475V8.733c0-.519-.467-.783-1.386-.783Z" /><path d="M18.826,14.95H15.975a.475.475,0,1,1,0-.95h2.851a.475.475,0,0,1,0,.95Z" transform="translate(-0.771 -0.348)" /><path d="M23.826,14.95H20.975a.475.475,0,0,1,0-.95h2.851a.475.475,0,0,1,0,.95Z" transform="translate(-1.02 -0.348)" /><path d="M27.876,14.95h-1.9a.475.475,0,1,1,0-.95h1.9a.475.475,0,0,1,0,.95Z" transform="translate(-1.269 -0.348)" /><path d="M5.376,18.552h-1.9A.476.476,0,0,1,3,18.077v-7.6A.475.475,0,0,1,3.475,10h1.9a.475.475,0,0,1,.475.475v7.6A.476.476,0,0,1,5.376,18.552ZM3.95,17.6H4.9V10.95H3.95Z" transform="translate(-0.149 -0.149)" /></g></svg>';
							}
							if($tab_slug == "nexter_site_performance"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="tachometer-alt-fastest" class="tab-nav-icon" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><path fill="currentColor" d="M120 320c0 13.26-10.74 24-24 24s-24-10.74-24-24 10.74-24 24-24 24 10.74 24 24zm168-168c13.26 0 24-10.74 24-24s-10.74-24-24-24-24 10.74-24 24 10.74 24 24 24zm136 56c13.26 0 24-10.74 24-24s-10.74-24-24-24-24 10.74-24 24 10.74 24 24 24zm71.78 109.38c1.47 8.72-4.44 16.95-13.16 18.41l-131.2 21.87C348.53 390.3 321.41 416 288 416c-35.35 0-64-28.65-64-64s28.65-64 64-64c26.09 0 48.44 15.66 58.41 38.05l130.97-21.83c8.53-1.49 16.93 4.44 18.4 13.16zM320 352c0-17.67-14.33-32-32-32s-32 14.33-32 32 14.33 32 32 32 32-14.33 32-32zM152 160c-13.26 0-24 10.74-24 24s10.74 24 24 24 24-10.74 24-24-10.74-24-24-24zm424 160c0 52.8-14.25 102.26-39.06 144.8-5.61 9.62-16.3 15.2-27.44 15.2h-443c-11.14 0-21.83-5.58-27.44-15.2C14.25 422.26 0 372.8 0 320 0 160.94 128.94 32 288 32s288 128.94 288 288zm-32 0c0-141.16-114.84-256-256-256S32 178.84 32 320c0 45.26 12 89.75 34.7 128.68l442.8-.68C532 409.75 544 365.26 544 320z"></path></svg>';
							}
							if($tab_slug == "nexter_site_security"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="shield-alt" class="tab-nav-icon" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M466.5 83.7l-192-80a48.15 48.15 0 0 0-36.9 0l-192 80C27.7 91.1 16 108.6 16 128c0 198.5 114.5 335.7 221.5 380.3 11.8 4.9 25.1 4.9 36.9 0C360.1 472.6 496 349.3 496 128c0-19.4-11.7-36.9-29.5-44.3zM262.2 478.8c-4 1.6-8.4 1.6-12.3 0C152 440 48 304 48 128c0-6.5 3.9-12.3 9.8-14.8l192-80c3.9-1.6 8.4-1.6 12.3 0l192 80c6 2.5 9.9 8.3 9.8 14.8.1 176-103.9 312-201.7 350.8zM256 411V100l-142.7 59.5c10.1 120.1 77.1 215 142.7 251.5zm-32-66.8c-36.4-39.9-65.8-97.8-76.1-164.5L224 148z"></path></svg>';
							}
							
							if($tab_slug == "nexter_extra_options"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="cogs" class="tab-nav-icon svg-inline--fa fa-cogs" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><path fill="currentColor" d="M538.6 196.4l-2.5-3.9c-4.1.3-8.1.3-12.2 0l-2.5 4c-5.8 9.2-17.1 13.4-27.5 10.1-13.8-4.3-23-8.8-34.3-18.1-9-7.4-11.2-20.3-5.4-30.4l2.5-4.3c-2.3-3.4-4.3-6.9-6.1-10.6h-9.1c-11.6 0-21.4-8.2-23.6-19.6-2.6-13.7-2.7-24.2.1-38.5 2.1-11.3 12.1-19.5 23.6-19.5h9c1.8-3.7 3.8-7.2 6.1-10.6l-2.6-4.5c-5.8-10-3.6-22.7 5.2-30.3 10.6-9.1 19.7-14.3 33.5-19 10.8-3.7 22.7.7 28.5 10.6l2.6 4.4c4.1-.3 8.1-.3 12.2 0l2.6-4.4c5.8-9.9 17.7-14.3 28.6-10.5 13.3 4.5 22.3 9.6 33.5 19.1 8.8 7.5 10.9 20.2 5.1 30.2l-2.6 4.4c2.3 3.4 4.3 6.9 6.1 10.6h5.1c11.6 0 21.4 8.2 23.6 19.6 2.6 13.7 2.7 24.2-.1 38.5-2.1 11.3-12.1 19.5-23.6 19.5h-5c-1.8 3.7-3.8 7.2-6.1 10.6l2.5 4.3c5.9 10.2 3.5 23.1-5.5 30.5-10.7 8.8-19.9 13.4-34 17.9-10.5 3.3-21.9-.8-27.7-10.1zm12.2-34.5l10.6 18.3c6.7-2.8 12.9-6.4 18.7-10.8l-10.6-18.3 6.4-7.5c4.8-5.7 8.6-12.1 11-19.1l3.3-9.3h21.1c.9-7.1.9-14.4 0-21.5h-21.1l-3.3-9.3c-2.5-7-6.2-13.4-11-19.1l-6.4-7.5L580 39.4c-5.7-4.4-12-8-18.7-10.8l-10.6 18.3-9.7-1.8c-7.3-1.4-14.8-1.4-22.1 0l-9.7 1.8-10.6-18.3C492 31.3 485.7 35 480 39.4l10.6 18.3-6.4 7.5c-4.8 5.7-8.6 12.1-11 19.1l-3.3 9.3h-21.1c-.9 7.1-.9 14.4 0 21.5h21.1l3.3 9.3c2.5 7 6.2 13.4 11 19.1l6.4 7.5-10.6 18.4c5.7 4.4 12 8 18.7 10.8l10.6-18.3 9.7 1.8c7.3 1.4 14.8 1.4 22.1 0l9.7-1.8zM145.3 454.4v-31.6c-12.9-5.5-25.1-12.6-36.4-21.1l-27.5 15.9c-9.8 5.6-22.1 3.7-29.7-4.6-24.2-26.3-38.5-49.5-50.6-88.1-3.4-10.7 1.1-22.3 10.8-28L39.2 281c-1.7-14-1.7-28.1 0-42.1l-27.3-15.8c-9.7-5.6-14.2-17.3-10.8-28 12.1-38.4 26.2-61.6 50.6-88.1 7.6-8.3 20-10.2 29.7-4.6l27.4 15.9c11.3-8.5 23.5-15.5 36.4-21.1V65.6c0-11.3 7.8-21 18.8-23.4 34.7-7.8 62-8.7 101.7 0 11 2.4 18.9 12.2 18.9 23.4v31.6c12.9 5.5 25.1 12.6 36.4 21l27.4-15.8c9.8-5.6 22.2-3.7 29.8 4.6 26.9 29.6 41.5 55.9 52.1 88.5 3.4 10.5-.8 21.9-10.2 27.7l-25 15.8c1.7 14 1.7 28.1 0 42.1l28.1 17.5c8.6 5.4 13 15.6 10.8 25.5-6.9 31.3-33 64.6-55.9 89.2-7.6 8.2-19.9 10-29.6 4.4L321 401.8c-11.3 8.5-23.5 15.5-36.4 21.1v31.6c0 11.2-7.8 21-18.8 23.4-37.5 8.3-64.9 8.2-101.9 0-10.8-2.5-18.6-12.3-18.6-23.5zm32-6.2c24.8 5 50.5 5 75.3 0v-47.7l10.7-3.8c16.8-5.9 32.3-14.9 45.9-26.5l8.6-7.4 41.4 23.9c16.8-19.1 34-41.3 42.1-65.2l-41.4-23.9 2.1-11.1c3.2-17.6 3.2-35.5 0-53.1l-2.1-11.1 41.4-23.9c-8.1-23.9-25.3-46.2-42.1-65.2l-41.4 23.9-8.6-7.4c-13.6-11.7-29-20.6-45.9-26.5l-10.7-3.8V71.8c-24.8-5-50.5-5-75.3 0v47.7l-10.7 3.8c-16.8 5.9-32.3 14.9-45.9 26.5l-8.6 7.4-41.4-23.9A192.19 192.19 0 0 0 33 198.5l41.4 23.9-2.1 11.1c-3.2 17.6-3.2 35.5 0 53.1l2.1 11.1L33 321.6c8.1 23.9 20.9 46.2 37.7 65.2l41.4-23.9 8.6 7.4c13.6 11.7 29 20.6 45.9 26.5l10.7 3.8v47.6zm38.4-105.3c-45.7 0-82.9-37.2-82.9-82.9s37.2-82.9 82.9-82.9 82.9 37.2 82.9 82.9-37.2 82.9-82.9 82.9zm0-133.8c-28 0-50.9 22.8-50.9 50.9s22.8 50.9 50.9 50.9c28 0 50.9-22.8 50.9-50.9s-22.8-50.9-50.9-50.9zm322.9 291.7l-2.5-3.9c-4.1.3-8.1.3-12.2 0l-2.5 4c-5.8 9.2-17.1 13.4-27.5 10.1-13.8-4.3-23-8.8-34.3-18.1-9-7.4-11.2-20.3-5.4-30.4l2.5-4.3c-2.3-3.4-4.3-6.9-6.1-10.6h-9.1c-11.6 0-21.4-8.2-23.6-19.6-2.6-13.7-2.7-24.2.1-38.5 2.1-11.3 12.1-19.5 23.6-19.5h9c1.8-3.7 3.8-7.2 6.1-10.6l-2.6-4.5c-5.8-10-3.6-22.7 5.2-30.3 10.6-9.1 19.7-14.3 33.5-19 10.8-3.7 22.7.7 28.5 10.6l2.6 4.4c4.1-.3 8.1-.3 12.2 0l2.6-4.4c5.8-9.9 17.7-14.3 28.6-10.5 13.3 4.5 22.3 9.6 33.5 19.1 8.8 7.5 10.9 20.2 5.1 30.2l-2.6 4.4c2.3 3.4 4.3 6.9 6.1 10.6h5.1c11.6 0 21.4 8.2 23.6 19.6 2.6 13.7 2.7 24.2-.1 38.5-2.1 11.3-12.1 19.5-23.6 19.5h-5c-1.8 3.7-3.8 7.2-6.1 10.6l2.5 4.3c5.9 10.2 3.5 23.1-5.5 30.5-10.7 8.8-19.9 13.4-34 17.9-10.5 3.2-21.9-.9-27.7-10.1zm12.2-34.6l10.6 18.3c6.7-2.8 12.9-6.4 18.7-10.8l-10.6-18.3 6.4-7.5c4.8-5.7 8.6-12.1 11-19.1l3.3-9.3h21.1c.9-7.1.9-14.4 0-21.5h-21.1l-3.3-9.3c-2.5-7-6.2-13.4-11-19.1l-6.4-7.5 10.6-18.3c-5.7-4.4-12-8-18.7-10.8l-10.6 18.3-9.7-1.8c-7.3-1.4-14.8-1.4-22.1 0l-9.7 1.8-10.6-18.3c-6.7 2.8-12.9 6.4-18.7 10.8l10.6 18.3-6.4 7.5c-4.8 5.7-8.6 12.1-11 19.1l-3.3 9.3h-21.1c-.9 7.1-.9 14.4 0 21.5h21.1l3.3 9.3c2.5 7 6.2 13.4 11 19.1l6.4 7.5-10.6 18.3c5.7 4.4 12 8 18.7 10.8l10.6-18.3 9.7 1.8c7.3 1.4 14.8 1.4 22.1 0l9.7-1.8zM560 408c0-17.7-14.3-32-32-32s-32 14.3-32 32 14.3 32 32 32 32-14.3 32-32zm0-304.3c0-17.7-14.3-32-32-32s-32 14.3-32 32 14.3 32 32 32 32-14.4 32-32z"></path></svg>';
							}
							
							if($tab_slug == "nexter_white_label"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg class="tab-nav-icon" xmlns="http://www.w3.org/2000/svg" width="30.152" height="27.537" viewBox="0 0 30.152 27.537">
								  <g transform="matrix(-0.788, 0.616, -0.616, -0.788, 34.922, 16.639)">
									<path d="M27.478,20.962H4.894a.466.466,0,0,1-.335-.144L.947,17.023a3.593,3.593,0,0,1,.008-5.266L4.567,8.136A.456.456,0,0,1,4.9,8H27.462a.462.462,0,0,1,.367.744L23.416,14.48l4.348,5.651a.466.466,0,0,1-.286.83ZM5.092,20.036H26.52l-4.056-5.273a.46.46,0,0,1,0-.564L26.52,8.927H5.086L1.609,12.412a2.671,2.671,0,0,0,0,3.966Z" />
									<path d="M6.33,17.43a2.778,2.778,0,1,1,2.778-2.778A2.782,2.782,0,0,1,6.33,17.43Zm0-4.629a1.852,1.852,0,1,0,1.852,1.852A1.853,1.853,0,0,0,6.33,12.8Z" transform="translate(-0.278 -0.287)"/>
									<path d="M18.581,13.926H13.026a.463.463,0,1,1,0-.926h5.555a.463.463,0,0,1,0,.926Z" transform="translate(-0.946 -0.371)"/>
									<path d="M18.581,16.926H13.026a.463.463,0,0,1,0-.926h5.555a.463.463,0,0,1,0,.926Z" transform="translate(-0.946 -0.593)"/>
								  </g>
								</svg>';
							}
							
							if($tab_slug == "nexter_import_data"){
								$nav_url = admin_url( 'admin.php?page=' . $tab_slug );
								$navicon = '<svg aria-hidden="true" focusable="false" data-prefix="fal" data-icon="file-import" class="svg-inline--fa fa-file-import fa-w-16 tab-nav-icon" role="img" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path fill="currentColor" d="M497.9 97.98L414.02 14.1c-9-9-21.2-14.1-33.89-14.1H175.99C149.5.1 128 21.6 128 48.09V288H8c-4.42 0-8 3.58-8 8v16c0 4.42 3.58 8 8 8h248v52.67c0 10.98 6.38 20.55 16.69 24.97 14.93 6.45 26.88-1.61 30.88-5.39l71.72-68.12c5.62-5.33 8.72-12.48 8.72-20.12s-3.09-14.8-8.69-20.11l-71.78-68.16c-8.28-7.8-20.41-9.88-30.84-5.38-10.31 4.42-16.69 13.98-16.69 24.97V288H160V48.09c0-8.8 7.2-16.09 16-16.09h176.04v104.07c0 13.3 10.7 23.93 24 23.93h103.98v304.01c0 8.8-7.2 16-16 16H175.99c-8.8 0-16-7.2-16-16V352H128v112.01c0 26.49 21.5 47.99 47.99 47.99h288.02c26.49 0 47.99-21.5 47.99-47.99V131.97c0-12.69-5.1-24.99-14.1-33.99zM288 245.12L350 304l-62 58.88V245.12zm96.03-117.05V32.59c2.8.7 5.3 2.1 7.4 4.2l83.88 83.88c2.1 2.1 3.5 4.6 4.2 7.4h-95.48z"></path></svg>';
							}
							$label_options=get_option( 'nexter_white_label' );
							if( (empty($label_options['nxt_hidden_label']) || $label_options['nxt_hidden_label']!='on') && ($tab_slug == "nexter_white_label" || $tab_slug == "nexter_activate") ){
								echo '<a class="'.esc_attr($nav_class).'" href="'.esc_url($nav_url).'">';
									echo '<span>'.$navicon.'</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
									echo '<span>'.esc_html($option_tab['title']).'</span>';
								echo '</a>';
							}else if(($tab_slug != "nexter_white_label" && $tab_slug != "nexter_activate") || !defined('NXT_PRO_EXT_VER')){
								echo '<a class="'.esc_attr($nav_class).'" href="'.esc_url($nav_url).'">';
									echo '<span>'.$navicon.'</span>'; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
									echo '<span>'.esc_html($option_tab['title']).'</span>';
								echo '</a>';
							}
						endforeach;
						$out = ob_get_clean();
						$output .= $out;
					$output .='</div>';
				$output .='</div>';
			
			$output .='</div>';
			
			
		
			/*Content Options*/
			$output .='<div class="nxt-settings-form-wrapper form-'.esc_attr($tab_forms[0]['id']).'">';
			
				if(!empty($tab_forms)){
					ob_start();
					foreach ($tab_forms as $tab_form):
						
						if($tab_form['id']=='nexter_white_label'){
							do_action('nexter_white_label_notice');
						}else if($tab_form['id']=='nexter_activate'){
							do_action('nexter_activate_notice');
						}else if($tab_form['id']=='nexter_import_data'){
							do_action('nexter_import_data_render');
						}else if($tab_form['id']=='nexter_extra_options'){
							do_action('nexter_extra_options_render');
						}else if(!defined('NEXTER_EXT') && $tab_form['id']=='nexter_site_performance'){
							do_action('nexter_site_performance_notice');
						}else if(!defined('NEXTER_EXT') && $tab_form['id']=='nexter_site_security'){
							do_action('nexter_site_security_notice');
						}
						
						if( ( defined('NXT_PRO_EXT') && $tab_form['id']=='nexter_white_label' ) || ( defined('NEXTER_EXT') && ($tab_form['id']=='nexter_site_performance' || $tab_form['id']=='nexter_site_security' )) ){
							cmb2_metabox_form($tab_form, $tab_form['id']);
						}else if($tab_form['id']=='nexter_settings_welcome'){
							include_once NXT_THEME_DIR . 'inc/panel-settings/welcome-page.php';
						}
					endforeach;
					$out = ob_get_clean();
					$output .= $out;
				}
			$output .='</div>';
			
		$output .='</div>';
		
		echo $output; // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
		
	}
	
	/**
     * Nexter Settings fields configuration
     */
    public function option_fields() {
		// Only need to initiate the array once per page-load
        if (!empty($this->option_metabox)) {
            return $this->option_metabox;
        }
		
		$this->option_metabox[] = array(
            'id' => 'nexter_settings_welcome',
            'title' => esc_html__('Welcome', 'nexter'),
            'show_on' => array(
                'key' => 'options-page',
                'value' => array(
                    'nexter_settings_welcome'
                )
            ),
            'show_names' => true,
            'fields' => ''
        );
		
		$this->option_metabox[] = array(
            'id' => 'nexter_import_data',
            'title' => esc_html__('Import', 'nexter'),
            'show_on' => array(
                'key' => 'options-page',
                'value' => array(
                    'nexter_import_data'
                )
            ),
            'show_names' => true,
            'fields' => ''
        );
		$this->option_metabox[] = array(
			'id' => 'nexter_extra_options',
			'title' => esc_html__('Extra Options', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_extra_options'
				)
			),
			'show_names' => true,
			'fields' => '',
		);
		
		$performance_options=[];
		if(has_filter('nexter_site_performance_options')) {
			$performance_options = apply_filters('nexter_site_performance_options', $performance_options);
		}
		
		$this->option_metabox[] = array(
			'id' => 'nexter_site_performance',
			'title' => esc_html__('Performance', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_site_performance'
				)
			),
			'show_names' => true,
			'fields' => $performance_options,
		);
		
		$security_options=[];
		if(has_filter('nexter_site_security_options')) {
			$security_options = apply_filters('nexter_site_security_options', $security_options);
		}
		$this->option_metabox[] = array(
			'id' => 'nexter_site_security',
			'title' => esc_html__('Security', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_site_security'
				)
			),
			'show_names' => true,
			'fields' => $security_options,
		);
		$this->option_metabox[] = array(
			'id' => 'nexter_activate',
			'title' => esc_html__('Activate', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_activate'
				)
			),
			'show_names' => true,
			'fields' => '',
		);
		
		$white_label_options=[];
		if(has_filter('nexter_white_label_options')) {
			$white_label_options = apply_filters('nexter_white_label_options', $white_label_options);
		}
		
		$this->option_metabox[] = array(
			'id' => 'nexter_white_label',
			'title' => esc_html__('White Label', 'nexter'),
			'show_on' => array(
				'key' => 'options-page',
				'value' => array(
					'nexter_white_label'
				)
			),
			'show_names' => true,
			'fields' => $white_label_options,
		);
		
		return $this->option_metabox;
	}
	
	/**
     * Public getter method for retrieving protected/private variables
     * @since  1.0.0
     * @param  string	$field Field to retrieve
     * @return mixed	Field value or exception is thrown
     */
    public function __get($field) {
        
        // Allowed fields to retrieve
        if (in_array($field, array('key','fields','title','options_page'), true)) {
            return $this->{$field};
        }
        if ('option_metabox' === $field) {
            return $this->option_fields();
        }
        /* translators: Invalid property: Fields */
        throw new Exception( sprintf( esc_html__( 'Invalid property: %1$s', 'nexter' ), $field ) );
    }
	
	/**
	 * Export Customizer options.
	 *
	 * @since 1.0.11
	 */
	public static function nxt_customizer_export_data() {
		if ( ! current_user_can( 'manage_options' ) ) {
			return;
		}
		if ( !isset( $_POST['nexter_export_cust_nonce'] ) || !wp_verify_nonce( $_POST['nexter_export_cust_nonce'], 'nexter_export_cust_nonce' ) ) {
			return;
		}
		if ( empty( $_POST['nxt_customizer_export_action'] ) || $_POST['nxt_customizer_export_action'] !== 'nxt_export_cust' ) {
			return;
		}

		// Get Customizer options
		$customizer_options = Nexter_Customizer_Options::get_options();

		$customizer_options = apply_filters( 'nexter_customizer_export_data', $customizer_options );
		nocache_headers();
		
		header( 'Content-Type: application/json; charset=utf-8' );
		header( 'Content-Disposition: attachment; filename=nexter-customizer-export-' . gmdate( 'm-d-Y' ) . '.json' );
		header( 'Expires: 0' );
		echo wp_json_encode( $customizer_options );
		die();
	}
	
	/**
	 * Import Customizer options.
	 *
	 * @since 1.0.11
	 */
	public static function nxt_customizer_import_data() {
		if ( ! current_user_can( 'manage_options' ) ) {
			return;
		}
		if ( !isset( $_POST['nexter_import_cust_nonce'] ) || !wp_verify_nonce( $_POST['nexter_import_cust_nonce'], 'nexter_import_cust_nonce' ) ) {
			return;
		}
		if ( empty( $_POST['nxt_customizer_import_action'] ) || $_POST['nxt_customizer_import_action'] !== 'nxt_import_cust' ) {
			return;
		}
		
		$filename = $_FILES['nxt_import_file']['name'];

		if ( empty( $filename ) ) {
			return;
		}
		
		$file_extension  = explode( '.', $filename );
		$extension = end( $file_extension );

		if ( $extension !== 'json' ) {
			wp_die( esc_html__( 'Valid .json file extension', 'nexter' ) );
		}

		$nxt_import_file = $_FILES['nxt_import_file']['tmp_name'];

		if ( empty( $nxt_import_file ) ) {
			wp_die( esc_html__( 'Please upload a file', 'nexter' ) );
		}

		global $wp_filesystem;
		if ( empty( $wp_filesystem ) ) {
			require_once ABSPATH . '/wp-admin/includes/file.php';
			WP_Filesystem();
		}
		
		$get_contants = $wp_filesystem->get_contents( $nxt_import_file );
		$customizer_options      = json_decode( $get_contants, 1 );
		if ( !empty( $customizer_options ) ) {
			update_option( 'nxt-theme-options', $customizer_options );
		}

		wp_safe_redirect(
			add_query_arg(
				array(
					'page'   => 'nexter_extra_options',
					'status_customizer' => 'success',
				),
				admin_url( 'admin.php' )
			),
		);
		exit;
	}
	
}

// Get it started
$Nexter_Settings_Panel = new Nexter_Settings_Panel();
$Nexter_Settings_Panel->hooks();